package interop_tests.apacheSoap ;

import java.io.*;
import java.net.*;
import java.util.*;
import org.apache.soap.*;
import org.apache.soap.rpc.*;
import org.apache.soap.transport.http.*
;
public class add_proxy {

  public static void main (String[] args) throws Exception {
    if (args.length != 3
        && (args.length != 4 || !args[0].startsWith ("-"))) {
      System.err.println ("Usage: java " + add_proxy.class.getName () +
                          " [-encodingStyleURI] SOAP-router-URL ValueA ValueB");
      System.exit (1);
    }

    // Process the arguments.
    int offset = 4 - args.length;
    String encodingStyleURI = args.length == 4
                              ? args[0].substring(1)
                              : Constants.NS_URI_SOAP_ENC;
    URL url = new URL (args[1 - offset]);
    String valA = args[2 - offset];
    String valB = args[3 - offset];

    // Build the call.
    Call call = new Call ();
    call.setTargetObjectURI ("http://simon.fell.com/calc");
    call.setMethodName ("Add");
    call.setEncodingStyleURI(encodingStyleURI);
    Vector params = new Vector ();
    params.addElement (new Parameter("a", String.class, valA, null));
    params.addElement (new Parameter("b", String.class, valB, null));
    call.setParams (params);

	// http connection info
	SOAPHTTPConnection http = new SOAPHTTPConnection() ;
	http.setProxyHost("localhost");
	http.setProxyPort(8080);
	call.setSOAPTransport(http) ;
	
    // make the call: note that the action URI is empty because the 
    // IBM-SOAP rpc router does not need this. This may change in the
    // future.
    Response resp = call.invoke (/* router URL */ url, /* actionURI */ "" );

    // Check the response.
    if (resp.generatedFault ()) {
      Fault fault = resp.getFault ();
      System.out.println ("Ouch, the call failed: ");
      System.out.println ("  Fault Code   = " + fault.getFaultCode ());  
      System.out.println ("  Fault String = " + fault.getFaultString ());
    } else {
      Parameter result = resp.getReturnValue ();
      System.out.println (valA + " + " + valB + " = " + result.getValue () + " (from " + url.toExternalForm() + ")" );
    }
  }
}
